FontMetrics

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt
Class FontMetrics

    java.lang.Object
      java.awt.FontMetrics

All Implemented Interfaces:
  Serializable

    public abstract class FontMetrics

extends Object
implements Serializable

The `FontMetrics` class defines a font metrics object, which encapsulates information about the rendering of a particular font on a particular screen.

Note to subclassers: Since many of these methods form closed, mutually recursive loops, you must take care that you implement at least one of the methods in each such loop to prevent infinite recursion when your subclass is used. In particular, the following is the minimal suggested set of methods to override in order to ensure correctness and prevent infinite recursion (though other subsets are equally feasible):

- `getAscent()`
- `getLeading()`
- `getMaxAdvance()`
- `charWidth(char)`
- `charsWidth(char[], int, int)`

Note that the implementations of these methods are inefficient, so they are usually overridden with more efficient toolkit-specific implementations.

When an application asks AWT to place a character at the position (x, y), the character is placed so that its reference point (shown as the dot in the accompanying image) is put at that position. The reference point specifies a horizontal line called the baseline of the character. In normal printing, the baselines of characters should align.

In addition, every character in a font has an ascent, a descent, and an advance width. The ascent is the amount by which the character ascends above the baseline. The descent is the amount by which the character descends below the baseline. The advance width indicates the position at which AWT should place the next character.

An array of characters or a string can also have an ascent, a descent, and an advance width. The ascent of the array is the maximum ascent of any character in the array. The descent is the maximum descent of any character in the array. The advance width is the sum of the advance widths of each of the characters in the character array. The advance of a `String` is the distance along the baseline of the `String`. This distance is the width that should be used for centering or right-aligning the `String`. Note that the advance of a `String` is not necessarily the sum of the advances of its characters measured in isolation because the width of a character can vary depending on its context. For example, in Arabic text, the shape of a character can change in order to connect to other characters. Also, in some scripts, certain character sequences can be represented by a single shape, called a ligature. Measuring characters individually does not account for these transformations.

Since:
  JDK1.0
Version:
  1.49 01/23/03
Author:
  Jim Graham
See Also:
  `Font`, Serialized Form

Method Summary
`int` | `bytesWidth(byte[] data, int off, int len)` Returns the total advance width for showing the specified array of bytes in this `Font`.
`int` | `charsWidth(char[] data, int off, int len)` Returns the total advance width for showing the specified array of characters in this `Font`.
`int` | `charWidth(char ch)` Returns the advance width of the specified character in this `Font`.
`int` | `charWidth(int ch)` Returns the advance width of the specified character in this `Font`.
`int` | `getAscent()` Determines the font ascent of the `Font` described by this `FontMetrics` object.
`int` | `getDescent()` Determines the font descent of the `Font` described by this `FontMetrics` object.
`Font` | `getFont()` Gets the `Font` described by this `FontMetrics` object.
`int` | `getHeight()` Gets the standard height of a line of text in this font.
`int` | `getLeading()` Determines the standard leading of the `Font` described by this `FontMetrics` object.
`int` | `getMaxAdvance()` Gets the maximum advance width of any character in this `Font`.
`int` | `getMaxAscent()` Determines the maximum ascent of the `Font` described by this `FontMetrics` object.
`int` | `getMaxDescent()` Determines the maximum descent of the `Font` described by this `FontMetrics` object.
`int[]` | `getWidths()` Gets the advance widths of the first 256 characters in the `Font`.
`int` | `stringWidth(String str)` Returns the total advance width for showing the specified `String` in this `Font`.
`String` | `toString()` Returns a representation of this `FontMetrics` object's values as a `String`.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### getFont

    public Font getFont()

  Gets the `Font` described by this `FontMetrics` object.

  Returns:
    the `Font` described by this `FontMetrics` object.

### getLeading

    public int getLeading()

  Determines the standard leading of the `Font` described by this `FontMetrics` object. The standard leading, or interline spacing, is the logical amount of space to be reserved between the descent of one line of text and the ascent of the next line. The height metric is calculated to include this extra space.

  Returns:
    the standard leading of the `Font`.
  See Also:
    `getHeight()`, `getAscent()`, `getDescent()`

### getAscent

    public int getAscent()

  Determines the font ascent of the `Font` described by this `FontMetrics` object. The font ascent is the distance from the font's baseline to the top of most alphanumeric characters. Some characters in the `Font` might extend above the font ascent line.

  Returns:
    the font ascent of the `Font`.
  See Also:
    `getMaxAscent()`

### getDescent

    public int getDescent()

  Determines the font descent of the `Font` described by this `FontMetrics` object. The font descent is the distance from the font's baseline to the bottom of most alphanumeric characters with descenders. Some characters in the `Font` might extend below the font descent line.

  Returns:
    the font descent of the `Font`.
  See Also:
    `getMaxDescent()`

### getHeight

    public int getHeight()

  Gets the standard height of a line of text in this font. This is the distance between the baseline of adjacent lines of text. It is the sum of the leading + ascent + descent. Due to rounding this may not be the same as getAscent() + getDescent() + getLeading(). There is no guarantee that lines of text spaced at this distance are disjoint; such lines may overlap if some characters overshoot either the standard ascent or the standard descent metric.

  Returns:
    the standard height of the font.
  See Also:
    `getLeading()`, `getAscent()`, `getDescent()`

### getMaxAscent

    public int getMaxAscent()

  Determines the maximum ascent of the `Font` described by this `FontMetrics` object. No character extends further above the font's baseline than this height.

  Returns:
    the maximum ascent of any character in the `Font`.
  See Also:
    `getAscent()`

### getMaxDescent

    public int getMaxDescent()

  Determines the maximum descent of the `Font` described by this `FontMetrics` object. No character extends further below the font's baseline than this height.

  Returns:
    the maximum descent of any character in the `Font`.
  See Also:
    `getDescent()`

### getMaxAdvance

    public int getMaxAdvance()

  Gets the maximum advance width of any character in this `Font`. The advance is the distance from the leftmost point to the rightmost point on the string's baseline. The advance of a `String` is not necessarily the sum of the advances of its characters.

  Returns:
    the maximum advance width of any character in the `Font`, or `-1` if the maximum advance width is not known.

### charWidth

    public int charWidth(int ch)

  Returns the advance width of the specified character in this `Font`. The advance is the distance from the leftmost point to the rightmost point on the character's baseline. Note that the advance of a `String` is not necessarily the sum of the advances of its characters.

  Parameters:
    `ch` - the character to be measured
  Returns:
    the advance width of the specified `char` in the `Font` described by this `FontMetrics` object.
  See Also:
    `charsWidth(char[], int, int)`, `stringWidth(String)`

### charWidth

    public int charWidth(char ch)

  Returns the advance width of the specified character in this `Font`. The advance is the distance from the leftmost point to the rightmost point on the character's baseline. Note that the advance of a `String` is not necessarily the sum of the advances of its characters.

  Parameters:
    `ch` - the character to be measured
  Returns:
    the advance width of the specified `char` in the `Font` described by this `FontMetrics` object.
  See Also:
    `charsWidth(char[], int, int)`, `stringWidth(String)`

### stringWidth

    public int stringWidth(String str)

  Returns the total advance width for showing the specified `String` in this `Font`. The advance is the distance from the leftmost point to the rightmost point on the string's baseline.

  Note that the total advance width returned from this method does not take into account the rendering context. Therefore, the anti-aliasing and fractional metrics hints can affect the value of the advance. The advance of a `String` is not necessarily the sum of the advances of its characters.

  Parameters:
    `str` - the `String` to be measured
  Returns:
    the advance width of the specified `String` in the `Font` described by this `FontMetrics`.
  See Also:
    `bytesWidth(byte[], int, int)`, `charsWidth(char[], int, int)`

### charsWidth

    public int charsWidth(char[] data,
                          int off,
                          int len)

  Returns the total advance width for showing the specified array of characters in this `Font`. The advance is the distance from the leftmost point to the rightmost point on the string's baseline. The advance of a `String` is not necessarily the sum of the advances of its characters. This is equivalent to measuring a `String` of the characters in the specified range.

  Parameters:
    `data` - the array of characters to be measured
    `off` - the start offset of the characters in the array
    `len` - the number of characters to be measured from the array
  Returns:
    the advance width of the subarray of the specified `char` array in the font described by this `FontMetrics` object.
  See Also:
    `charWidth(int)`, `charWidth(char)`, `bytesWidth(byte[], int, int)`, `stringWidth(String)`

### bytesWidth

    public int bytesWidth(byte[] data,
                          int off,
                          int len)

  Returns the total advance width for showing the specified array of bytes in this `Font`. The advance is the distance from the leftmost point to the rightmost point on the string's baseline. The advance of a `String` is not necessarily the sum of the advances of its characters. This is equivalent to measuring a `String` of the characters in the specified range.

  Parameters:
    `data` - the array of bytes to be measured
    `off` - the start offset of the bytes in the array
    `len` - the number of bytes to be measured from the array
  Returns:
    the advance width of the subarray of the specified `byte` array in the `Font` described by this `FontMetrics` object.
  See Also:
    `charsWidth(char[], int, int)`, `stringWidth(String)`

### getWidths

    public int[] getWidths()

  Gets the advance widths of the first 256 characters in the `Font`. The advance is the distance from the leftmost point to the rightmost point on the character's baseline. Note that the advance of a `String` is not necessarily the sum of the advances of its characters.

  Returns:
    an array storing the advance widths of the characters in the `Font` described by this `FontMetrics` object.

### toString

    public String toString()

  Returns a representation of this `FontMetrics` object's values as a `String`.

  Overrides:
    `toString` in class `Object`
  Returns:
    a `String` representation of this `FontMetrics` object.
  Since:
    JDK1.0.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD